Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/cassandra/CassandraMetricRepo.java
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/cassandra/CassandraMetricRepo.java
@@ -0,0 +1,336 @@
+/*
+ * Copyright (c) 2017 SUSE LLC
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+ * implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package monasca.persister.repository.cassandra;
+
+import java.security.NoSuchAlgorithmException;
+import java.sql.SQLException;
+import java.sql.Timestamp;
+import java.util.ArrayList;
+import java.util.Deque;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+import java.util.Map.Entry;
+import java.util.TreeMap;
+import java.util.concurrent.ExecutionException;
+import java.util.concurrent.TimeUnit;
+
+import javax.inject.Inject;
+
+import org.apache.commons.codec.digest.DigestUtils;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import com.codahale.metrics.Meter;
+import com.datastax.driver.core.BatchStatement;
+import com.datastax.driver.core.BoundStatement;
+import com.datastax.driver.core.ResultSet;
+import com.datastax.driver.core.ResultSetFuture;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+import com.google.common.util.concurrent.Futures;
+import com.google.common.util.concurrent.ListenableFuture;
+
+import io.dropwizard.setup.Environment;
+import monasca.common.model.metric.Metric;
+import monasca.common.model.metric.MetricEnvelope;
+import monasca.persister.configuration.PersisterConfig;
+import monasca.persister.repository.Repo;
+import monasca.persister.repository.RepoException;
+import monasca.persister.repository.Sha1HashId;
+
+public class CassandraMetricRepo extends CassandraRepo implements Repo<MetricEnvelope> {
+
+  private static final Logger logger = LoggerFactory.getLogger(CassandraMetricRepo.class);
+
+  public static final int MAX_COLUMN_LENGTH = 255;
+  public static final int MAX_VALUE_META_LENGTH = 2048;
+
+  private static final String TENANT_ID = "tenantId";
+  private static final String REGION = "region";
+  private static final String EMPTY_STR = "";
+
+  private int retention;
+
+  private CassandraMetricBatch batches;
+
+  private int metricCount;
+
+  private final ObjectMapper objectMapper = new ObjectMapper();
+
+  public final Meter measurementMeter;
+  public final Meter metricCacheMissMeter;
+  public final Meter metricCacheHitMeter;
+  public final Meter dimensionCacheMissMeter;
+  public final Meter dimensionCacheHitMeter;
+  public final Meter metricDimensionCacheMissMeter;
+  public final Meter metricDimensionCacheHitMeter;
+
+  @Inject
+  public CassandraMetricRepo(CassandraCluster cluster, PersisterConfig config, Environment environment)
+      throws NoSuchAlgorithmException, SQLException {
+
+    super(cluster, environment, config.getCassandraDbConfiguration().getMaxWriteRetries(),
+        config.getMetricConfiguration().getBatchSize());
+
+    logger.debug("Instantiating " + this.getClass().getName());
+
+    this.retention = config.getCassandraDbConfiguration().getRetentionPolicy() * 24 * 3600;
+
+    this.measurementMeter = this.environment.metrics()
+        .meter(this.getClass().getName() + "." + "measurement-meter");
+
+    this.metricCacheMissMeter = this.environment.metrics()
+        .meter(this.getClass().getName() + "." + "definition-cache-miss-meter");
+
+    this.metricCacheHitMeter = this.environment.metrics()
+        .meter(this.getClass().getName() + "." + "definition-cache-hit-meter");
+
+    this.dimensionCacheMissMeter = this.environment.metrics()
+        .meter(this.getClass().getName() + "." + "dimension-cache-miss-meter");
+
+    this.dimensionCacheHitMeter = this.environment.metrics()
+        .meter(this.getClass().getName() + "." + "dimension-cache-hit-meter");
+
+    this.metricDimensionCacheMissMeter = this.environment.metrics()
+        .meter(this.getClass().getName() + "." + "metric-dimension-cache-miss-meter");
+
+    this.metricDimensionCacheHitMeter = this.environment.metrics()
+        .meter(this.getClass().getName() + "." + "metric-dimension-cache-hit-meter");
+
+    session = cluster.getMetricsSession();
+
+    metricCount = 0;
+
+    batches = new CassandraMetricBatch(cluster.getMetaData(), cluster.getProtocolOptions(),
+        cluster.getCodecRegistry(), cluster.getLoadBalancePolicy(),
+        config.getCassandraDbConfiguration().getMaxBatches());
+
+
+
+    logger.debug(this.getClass().getName() + " is fully instantiated");
+  }
+
+  @Override
+  public void addToBatch(MetricEnvelope metricEnvelope, String id) {
+    Metric metric = metricEnvelope.metric;
+    Map<String, Object> metaMap = metricEnvelope.meta;
+
+    String tenantId = getMeta(TENANT_ID, metric, metaMap, id);
+    String region = getMeta(REGION, metric, metaMap, id);
+    String metricName = metric.getName();
+    TreeMap<String, String> dimensions = metric.getDimensions() == null ? new TreeMap<String, String>()
+        : new TreeMap<>(metric.getDimensions());
+
+    StringBuilder sb = new StringBuilder(region).append(tenantId).append(metricName);
+
+    Iterator<String> it = dimensions.keySet().iterator();
+    while (it.hasNext()) {
+      String k = it.next();
+      sb.append(k).append(dimensions.get(k));
+    }
+
+    byte[] defIdSha = DigestUtils.sha(sb.toString());
+    Sha1HashId defIdShaHash = new Sha1HashId(defIdSha);
+
+    if (cluster.getMetricIdCache().getIfPresent(defIdShaHash.toHexString()) == null) {
+      addDefinitionToBatch(defIdShaHash, metricName, dimensions, tenantId, region, id,
+          metric.getTimestamp());
+      batches.addMeasurementQuery(buildMeasurementInsertQuery(defIdShaHash, metric.getTimestamp(),
+          metric.getValue(), metric.getValueMeta(), region, tenantId, metricName, dimensions, id));
+    } else {
+      metricCacheHitMeter.mark();
+      batches.addMetricQuery(cluster.getMetricUpdateStmt().bind(retention,
+          new Timestamp(metric.getTimestamp()), region, tenantId, metricName,
+          getDimensionList(dimensions), new ArrayList<>(dimensions.keySet())));
+      batches.addMeasurementQuery(buildMeasurementUpdateQuery(defIdShaHash, metric.getTimestamp(),
+          metric.getValue(), metric.getValueMeta(), id));
+    }
+
+    metricCount++;
+  }
+
+  private String getMeta(String name, Metric metric, Map<String, Object> meta, String id) {
+    if (meta.containsKey(name)) {
+      return (String) meta.get(name);
+    } else {
+      logger.warn(
+          "[{}]: failed to find {} in message envelope meta data. metric message may be malformed. "
+              + "setting {} to empty string.",
+          id, name);
+      logger.warn("[{}]: metric: {}", id, metric.toString());
+      logger.warn("[{}]: meta: {}", id, meta.toString());
+      return EMPTY_STR;
+    }
+  }
+
+  private BoundStatement buildMeasurementUpdateQuery(Sha1HashId defId, long timeStamp, double value,
+      Map<String, String> valueMeta, String id) {
+
+    String valueMetaString = getValueMetaString(valueMeta, id);
+    if (logger.isDebugEnabled()) {
+      logger.debug("[{}]: adding metric to batch: metric id: {}, time: {}, value: {}, value meta {}",
+          id, defId.toHexString(), timeStamp, value, valueMetaString);
+    }
+
+    return cluster.getMeasurementUpdateStmt().bind(retention, value, valueMetaString,
+        defId.getSha1HashByteBuffer(), new Timestamp(timeStamp));
+  }
+
+  private BoundStatement buildMeasurementInsertQuery(Sha1HashId defId, long timeStamp, double value,
+      Map<String, String> valueMeta, String region, String tenantId, String metricName,
+      Map<String, String> dimensions, String id) {
+
+    String valueMetaString = getValueMetaString(valueMeta, id);
+    if (logger.isDebugEnabled()) {
+      logger.debug("[{}]: adding metric to batch: metric id: {}, time: {}, value: {}, value meta {}",
+          id, defId.toHexString(), timeStamp, value, valueMetaString);
+    }
+
+    measurementMeter.mark();
+    return cluster.getMeasurementInsertStmt().bind(retention, value, valueMetaString, region, tenantId,
+        metricName, getDimensionList(dimensions), defId.getSha1HashByteBuffer(),
+        new Timestamp(timeStamp));
+  }
+
+  private String getValueMetaString(Map<String, String> valueMeta, String id) {
+
+    String valueMetaString = "";
+
+    if (valueMeta != null && !valueMeta.isEmpty()) {
+
+      try {
+
+        valueMetaString = this.objectMapper.writeValueAsString(valueMeta);
+        if (valueMetaString.length() > MAX_VALUE_META_LENGTH) {
+          logger.error("[{}]: Value meta length {} longer than maximum {}, dropping value meta", id,
+              valueMetaString.length(), MAX_VALUE_META_LENGTH);
+          return "";
+        }
+
+      } catch (JsonProcessingException e) {
+
+        logger.error("[{}]: Failed to serialize value meta {}, dropping value meta from measurement",
+            id, valueMeta);
+      }
+    }
+
+    return valueMetaString;
+  }
+
+  private void addDefinitionToBatch(Sha1HashId defId, String metricName, Map<String, String> dimensions,
+      String tenantId, String region, String id, long timestamp) {
+
+    metricCacheMissMeter.mark();
+    if (logger.isDebugEnabled()) {
+      logger.debug("[{}]: adding definition to batch: defId: {}, name: {}, tenantId: {}, region: {}",
+          id, defId.toHexString(), metricName, tenantId, region);
+    }
+
+    Timestamp ts = new Timestamp(timestamp);
+    batches.addMetricQuery(
+        cluster.getMetricInsertStmt().bind(retention, defId.getSha1HashByteBuffer(), ts, ts, region,
+            tenantId, metricName, getDimensionList(dimensions), new ArrayList<>(dimensions.keySet())));
+
+    for (Map.Entry<String, String> entry : dimensions.entrySet()) {
+      String name = entry.getKey();
+      String value = entry.getValue();
+
+      String dimensionKey = cluster.getDimnesionEntryKey(region, tenantId, name, value);
+      if (cluster.getDimensionCache().getIfPresent(dimensionKey) != null) {
+        dimensionCacheHitMeter.mark();
+
+      } else {
+        dimensionCacheMissMeter.mark();
+        if (logger.isDebugEnabled()) {
+          logger.debug("[{}]: adding dimension to batch: defId: {}, name: {}, value: {}", id,
+              defId.toHexString(), name, value);
+        }
+        batches.addDimensionQuery(cluster.getDimensionStmt().bind(region, tenantId, name, value));
+        cluster.getDimensionCache().put(dimensionKey, Boolean.TRUE);
+      }
+
+      String metricDimensionKey = cluster.getMetricDimnesionEntryKey(region, tenantId, metricName, name, value);
+      if (cluster.getMetricDimensionCache().getIfPresent(metricDimensionKey) != null) {
+        metricDimensionCacheHitMeter.mark();
+      } else {
+        metricDimensionCacheMissMeter.mark();
+        batches.addDimensionMetricQuery(
+            cluster.getDimensionMetricStmt().bind(region, tenantId, name, value, metricName));
+
+        batches.addMetricDimensionQuery(
+            cluster.getMetricDimensionStmt().bind(region, tenantId, metricName, name, value));
+        cluster.getMetricDimensionCache().put(metricDimensionKey, Boolean.TRUE);
+      }
+    }
+
+    String metricId = defId.toHexString();
+    cluster.getMetricIdCache().put(metricId, Boolean.TRUE);
+  }
+
+  public List<String> getDimensionList(Map<String, String> dimensions) {
+    List<String> list = new ArrayList<>(dimensions.size());
+    for (Entry<String, String> dim : dimensions.entrySet()) {
+      list.add(new StringBuffer(dim.getKey()).append('\t').append(dim.getValue()).toString());
+    }
+    return list;
+  }
+
+  @Override
+  public int flush(String id) throws RepoException {
+    long startTime = System.nanoTime();
+    List<ResultSetFuture> results = new ArrayList<>();
+    List<Deque<BatchStatement>> list = batches.getAllBatches();
+    for (Deque<BatchStatement> q : list) {
+      BatchStatement b;
+      while ((b = q.poll()) != null) {
+        results.add(session.executeAsync(b));
+      }
+    }
+
+    List<ListenableFuture<ResultSet>> futures = Futures.inCompletionOrder(results);
+
+    boolean cancel = false;
+    Exception ex = null;
+    for (ListenableFuture<ResultSet> future : futures) {
+      if (cancel) {
+        future.cancel(false);
+        continue;
+      }
+      try {
+        future.get();
+      } catch (InterruptedException | ExecutionException e) {
+        cancel = true;
+        ex = e;
+      }
+    }
+
+    this.commitTimer.update(System.nanoTime() - startTime, TimeUnit.NANOSECONDS);
+
+    if (ex != null) {
+      metricFailed.inc(metricCount);
+      throw new RepoException(ex);
+    }
+
+    batches.clear();
+    int flushCnt = metricCount;
+    metricCount = 0;
+    metricCompleted.inc(flushCnt);
+    return flushCnt;
+  }
+}
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/cassandra/CassandraRepo.java
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/cassandra/CassandraRepo.java
@@ -0,0 +1,210 @@
+/*
+ * Copyright (c) 2017 SUSE LLC
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+ * implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package monasca.persister.repository.cassandra;
+
+import java.util.ArrayDeque;
+import java.util.ArrayList;
+import java.util.Deque;
+import java.util.List;
+import java.util.concurrent.ExecutionException;
+import java.util.concurrent.TimeUnit;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import com.codahale.metrics.Counter;
+import com.codahale.metrics.Timer;
+import com.datastax.driver.core.BatchStatement;
+import com.datastax.driver.core.BatchStatement.Type;
+import com.datastax.driver.core.ResultSet;
+import com.datastax.driver.core.ResultSetFuture;
+import com.datastax.driver.core.Session;
+import com.datastax.driver.core.Statement;
+import com.datastax.driver.core.exceptions.BootstrappingException;
+import com.datastax.driver.core.exceptions.DriverException;
+import com.datastax.driver.core.exceptions.NoHostAvailableException;
+import com.datastax.driver.core.exceptions.OperationTimedOutException;
+import com.datastax.driver.core.exceptions.OverloadedException;
+import com.datastax.driver.core.exceptions.QueryConsistencyException;
+import com.datastax.driver.core.exceptions.UnavailableException;
+import com.google.common.util.concurrent.Futures;
+import com.google.common.util.concurrent.ListenableFuture;
+
+import io.dropwizard.setup.Environment;
+import monasca.persister.repository.RepoException;
+
+public abstract class CassandraRepo {
+  private static Logger logger = LoggerFactory.getLogger(CassandraRepo.class);
+
+  final Environment environment;
+
+  final Timer commitTimer;
+
+  CassandraCluster cluster;
+  Session session;
+
+  int maxWriteRetries;
+
+  int batchSize;
+
+  long lastFlushTimeStamp;
+
+  Deque<Statement> queue;
+
+  Counter metricCompleted;
+
+  Counter metricFailed;
+
+  public CassandraRepo(CassandraCluster cluster, Environment env, int maxWriteRetries, int batchSize) {
+    this.cluster = cluster;
+    this.maxWriteRetries = maxWriteRetries;
+    this.batchSize = batchSize;
+
+    this.environment = env;
+
+    this.commitTimer = this.environment.metrics().timer(getClass().getName() + "." + "commit-timer");
+
+    lastFlushTimeStamp = System.currentTimeMillis();
+
+    queue = new ArrayDeque<>(batchSize);
+
+    this.metricCompleted = environment.metrics()
+        .counter(getClass().getName() + "." + "metrics-persisted-counter");
+
+    this.metricFailed = environment.metrics()
+        .counter(getClass().getName() + "." + "metrics-failed-counter");
+  }
+
+  protected void executeQuery(String id, Statement query, long startTime) throws DriverException {
+    _executeQuery(id, query, startTime, 0);
+  }
+
+  private void _executeQuery(final String id, final Statement query, final long startTime,
+      final int retryCount) {
+    try {
+      session.execute(query);
+
+      commitTimer.update(System.nanoTime() - startTime, TimeUnit.NANOSECONDS);
+
+      // ResultSetFuture future = session.executeAsync(query);
+
+      // Futures.addCallback(future, new FutureCallback<ResultSet>() {
+      // @Override
+      // public void onSuccess(ResultSet result) {
+      // metricCompleted.inc();
+      // commitTimer.update(System.nanoTime() - startTime, TimeUnit.NANOSECONDS);
+      // }
+      //
+      // @Override
+      // public void onFailure(Throwable t) {
+      // if (t instanceof NoHostAvailableException | t instanceof
+      // BootstrappingException
+      // | t instanceof OverloadedException | t instanceof QueryConsistencyException
+      // | t instanceof UnavailableException) {
+      // retryQuery(id, query, startTime, retryCount, (DriverException) t);
+      // } else {
+      // metricFailed.inc();
+      // commitTimer.update(System.nanoTime() - startTime, TimeUnit.NANOSECONDS);
+      // logger.error("Failed to execute query.", t);
+      // }
+      // }
+      // }, MoreExecutors.sameThreadExecutor());
+
+    } catch (NoHostAvailableException | BootstrappingException | OverloadedException
+        | QueryConsistencyException | UnavailableException | OperationTimedOutException e) {
+      retryQuery(id, query, startTime, retryCount, e);
+    } catch (DriverException e) {
+      metricFailed.inc(((BatchStatement) query).size());
+      commitTimer.update(System.nanoTime() - startTime, TimeUnit.NANOSECONDS);
+      throw e;
+    }
+  }
+
+  private void retryQuery(String id, Statement query, final long startTime, int retryCount,
+      DriverException e) throws DriverException {
+    if (retryCount >= maxWriteRetries) {
+      logger.error("[{}]: Query aborted after {} retry: ", id, retryCount, e.getMessage());
+      metricFailed.inc(((BatchStatement) query).size());
+      commitTimer.update(System.nanoTime() - startTime, TimeUnit.NANOSECONDS);
+      throw e;
+    } else {
+      logger.warn("[{}]: Query failed, retrying {} of {}: {} ", id, retryCount, maxWriteRetries,
+          e.getMessage());
+
+      try {
+        Thread.sleep(1000 * (1 << retryCount));
+      } catch (InterruptedException ie) {
+        logger.debug("[{}]: Interrupted: {}", id, ie);
+      }
+      _executeQuery(id, query, startTime, retryCount++);
+    }
+  }
+
+  public int handleFlush_batch(String id) {
+    Statement query;
+    int flushedCount = 0;
+
+    BatchStatement batch = new BatchStatement(Type.UNLOGGED);
+    while ((query = queue.poll()) != null) {
+      flushedCount++;
+      batch.add(query);
+    }
+
+    executeQuery(id, batch, System.nanoTime());
+
+    metricCompleted.inc(flushedCount);
+
+    return flushedCount;
+  }
+
+  public int handleFlush(String id) throws RepoException {
+    long startTime = System.nanoTime();
+
+    int flushedCount = 0;
+    List<ResultSetFuture> results = new ArrayList<>(queue.size());
+    Statement query;
+    while ((query = queue.poll()) != null) {
+      flushedCount++;
+      results.add(session.executeAsync(query));
+    }
+
+    List<ListenableFuture<ResultSet>> futures = Futures.inCompletionOrder(results);
+
+    boolean cancel = false;
+    Exception ex = null;
+    for (ListenableFuture<ResultSet> future : futures) {
+      if (cancel) {
+        future.cancel(false);
+        continue;
+      }
+      try {
+        future.get();
+      } catch (InterruptedException | ExecutionException e) {
+        cancel = true;
+        ex = e;
+      }
+    }
+
+    commitTimer.update(System.nanoTime() - startTime, TimeUnit.NANOSECONDS);
+
+    if (ex != null) {
+      throw new RepoException(ex);
+    }
+    return flushedCount;
+  }
+}
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/cassandra/MonascaRetryPolicy.java
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/cassandra/MonascaRetryPolicy.java
@@ -0,0 +1,77 @@
+package monasca.persister.repository.cassandra;
+
+import com.datastax.driver.core.Cluster;
+import com.datastax.driver.core.ConsistencyLevel;
+import com.datastax.driver.core.Statement;
+import com.datastax.driver.core.WriteType;
+import com.datastax.driver.core.exceptions.DriverException;
+import com.datastax.driver.core.policies.RetryPolicy;
+
+public class MonascaRetryPolicy implements RetryPolicy {
+
+  private final int readAttempts;
+  private final int writeAttempts;
+  private final int unavailableAttempts;
+
+  public MonascaRetryPolicy(int readAttempts, int writeAttempts, int unavailableAttempts) {
+    super();
+    this.readAttempts = readAttempts;
+    this.writeAttempts = writeAttempts;
+    this.unavailableAttempts = unavailableAttempts;
+  }
+
+  @Override
+  public RetryDecision onReadTimeout(Statement stmnt, ConsistencyLevel cl, int requiredResponses,
+      int receivedResponses, boolean dataReceived, int rTime) {
+    if (dataReceived) {
+      return RetryDecision.ignore();
+    } else if (rTime < readAttempts) {
+      return receivedResponses >= requiredResponses ? RetryDecision.retry(cl)
+          : RetryDecision.rethrow();
+    } else {
+      return RetryDecision.rethrow();
+    }
+
+  }
+
+  @Override
+  public RetryDecision onWriteTimeout(Statement stmnt, ConsistencyLevel cl, WriteType wt,
+      int requiredResponses, int receivedResponses, int wTime) {
+    if (wTime >= writeAttempts)
+      return RetryDecision.rethrow();
+
+    return RetryDecision.retry(cl);
+  }
+
+  @Override
+  public RetryDecision onUnavailable(Statement stmnt, ConsistencyLevel cl, int requiredResponses,
+      int receivedResponses, int uTime) {
+    if (uTime == 0) {
+      return RetryDecision.tryNextHost(cl);
+    } else if (uTime <= unavailableAttempts) {
+      return RetryDecision.retry(cl);
+    } else {
+      return RetryDecision.rethrow();
+    }
+  }
+
+  /**
+   * {@inheritDoc}
+   */
+  @Override
+  public RetryDecision onRequestError(Statement statement, ConsistencyLevel cl, DriverException e,
+      int nbRetry) {
+    return RetryDecision.tryNextHost(cl);
+  }
+
+  @Override
+  public void init(Cluster cluster) {
+    // nothing to do
+  }
+
+  @Override
+  public void close() {
+    // nothing to do
+  }
+
+}
Index: monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/vertica/VerticaMetricRepo.java
===================================================================
--- monasca-persister-1.7.1.dev2.orig/java/src/main/java/monasca/persister/repository/vertica/VerticaMetricRepo.java
+++ monasca-persister-1.7.1.dev2/java/src/main/java/monasca/persister/repository/vertica/VerticaMetricRepo.java
@@ -1,6 +1,8 @@
 /*
  * (C) Copyright 2014-2016 Hewlett Packard Enterprise Development LP
  *
+ * (C) Copyright 2017 SUSE LLC.
+ *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
@@ -50,6 +52,7 @@ import monasca.common.model.metric.Metri
 import monasca.persister.configuration.PersisterConfig;
 import monasca.persister.repository.Repo;
 import monasca.persister.repository.RepoException;
+import monasca.persister.repository.Sha1HashId;
 
 public class VerticaMetricRepo extends VerticaRepo implements Repo<MetricEnvelope> {
 
Index: monasca-persister-1.7.1.dev2/monasca_persister/conf/cassandra.py
===================================================================
--- monasca-persister-1.7.1.dev2.orig/monasca_persister/conf/cassandra.py
+++ monasca-persister-1.7.1.dev2/monasca_persister/conf/cassandra.py
@@ -1,6 +1,7 @@
 # (C) Copyright 2016 Hewlett Packard Enterprise Development Company LP
 # Copyright 2017 FUJITSU LIMITED
-#
+# (C) Copyright 2017 SUSE LLC
+
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
@@ -17,13 +18,47 @@
 from oslo_config import cfg
 
 cassandra_opts = [
-    cfg.ListOpt('cluster_ip_addresses',
+    cfg.ListOpt('contact_points',
                 help='Comma separated list of Cassandra node IP addresses',
                 default=['127.0.0.1'],
                 item_type=cfg.IPOpt),
+    cfg.IntOpt('port',
+               help='Cassandra port number',
+               default=8086),
     cfg.StrOpt('keyspace',
-               help='keyspace where metric are stored',
-               default='monasca')]
+               help='Keyspace name where metrics are stored',
+               default='monasca'),
+    cfg.StrOpt('user',
+               help='Cassandra user name',
+               default=''),
+    cfg.StrOpt('password',
+               help='Cassandra password',
+               secret=True,
+               default=''),
+    cfg.IntOpt('connection_timeout',
+               help='Cassandra timeout in seconds when creating a new connection',
+               default=5),
+    cfg.IntOpt('read_timeout',
+               help='Cassandra read timeout in seconds',
+               default=60),
+    cfg.IntOpt('max_write_retries',
+               help='Maximum number of retries in write ops',
+               default=1),
+    cfg.IntOpt('max_definition_cache_size',
+               help='Maximum number of cached metric definition entries in memory',
+               default=20000000),
+    cfg.IntOpt('retention_policy',
+               help='Data retention period in days',
+               default=45),
+    cfg.StrOpt('consistency_level',
+               help='Cassandra default consistency level',
+               default='ONE'),
+    cfg.StrOpt('local_data_center',
+               help='Cassandra local data center name'),
+    cfg.IntOpt('max_batches',
+               help='Maximum batch size in Cassandra',
+               default=250),
+]
 
 cassandra_group = cfg.OptGroup(name='cassandra')
 
Index: monasca-persister-1.7.1.dev2/monasca_persister/conf/kafka_alarm_history.py
===================================================================
--- monasca-persister-1.7.1.dev2.orig/monasca_persister/conf/kafka_alarm_history.py
+++ monasca-persister-1.7.1.dev2/monasca_persister/conf/kafka_alarm_history.py
@@ -1,5 +1,6 @@
 # (C) Copyright 2016-2017 Hewlett Packard Enterprise Development LP
 # Copyright 2017 FUJITSU LIMITED
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -37,7 +38,10 @@ kafka_alarm_history_opts = [
                default='alarm-state-transitions'),
     cfg.StrOpt('zookeeper_path',
                help='Path in zookeeper for kafka consumer group partitioning algorithm',
-               default='/persister_partitions/$kafka_alarm_history.topic')
+               default='/persister_partitions/$kafka_alarm_history.topic'),
+    cfg.IntOpt('batch_size',
+               help='Maximum number of alarm state history messages to buffer before writing to database',
+               default=1),
 ]
 
 
Index: monasca-persister-1.7.1.dev2/monasca_persister/conf/kafka_common.py
===================================================================
--- monasca-persister-1.7.1.dev2.orig/monasca_persister/conf/kafka_common.py
+++ monasca-persister-1.7.1.dev2/monasca_persister/conf/kafka_common.py
@@ -1,5 +1,6 @@
 # (C) Copyright 2016-2017 Hewlett Packard Enterprise Development LP
 # Copyright 2017 FUJITSU LIMITED
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -26,9 +27,6 @@ kafka_common_opts = [
                help='id of persister kafka client',
                advanced=True,
                default='monasca-persister'),
-    cfg.IntOpt('database_batch_size',
-               help='Maximum number of metric to buffer before writing to database',
-               default=1000),
     cfg.IntOpt('max_wait_time_seconds',
                help='Maximum wait time for write batch to database',
                default=30),
Index: monasca-persister-1.7.1.dev2/monasca_persister/conf/kafka_metrics.py
===================================================================
--- monasca-persister-1.7.1.dev2.orig/monasca_persister/conf/kafka_metrics.py
+++ monasca-persister-1.7.1.dev2/monasca_persister/conf/kafka_metrics.py
@@ -38,6 +38,9 @@ kafka_metrics_opts = [
     cfg.StrOpt('zookeeper_path',
                help='Path in zookeeper for kafka consumer group partitioning algorithm',
                default='/persister_partitions/$kafka_metrics.topic'),
+    cfg.IntOpt('batch_size',
+               help='Maximum number of metrics to buffer before writing to database',
+               default=20000),
 ]
 
 # Replace Default OPt with reference to kafka group option
Index: monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/abstract_repository.py
===================================================================
--- monasca-persister-1.7.1.dev2.orig/monasca_persister/repositories/cassandra/abstract_repository.py
+++ monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/abstract_repository.py
@@ -1,4 +1,5 @@
 # (C) Copyright 2016 Hewlett Packard Enterprise Development Company LP
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -12,26 +13,23 @@
 # implied.
 # See the License for the specific language governing permissions and
 # limitations under the License.
+
 import abc
-from cassandra import cluster
-from cassandra import query
 from oslo_config import cfg
 import six
 
 from monasca_persister.repositories import abstract_repository
+from monasca_persister.repositories.cassandra import connection_util
 
+conf = cfg.CONF
 
 @six.add_metaclass(abc.ABCMeta)
 class AbstractCassandraRepository(abstract_repository.AbstractRepository):
-
     def __init__(self):
         super(AbstractCassandraRepository, self).__init__()
-        self.conf = cfg.CONF
-
-        self._cassandra_cluster = cluster.Cluster(
-                self.conf.cassandra.cluster_ip_addresses.split(','))
-
-        self.cassandra_session = self._cassandra_cluster.connect(
-                self.conf.cassandra.keyspace)
 
-        self._batch_stmt = query.BatchStatement()
+        self._cluster = connection_util.create_cluster()
+        self._session = connection_util.create_session(self._cluster)
+        self._retention = conf.cassandra.retention_policy * 24 * 3600
+        self._cache_size = conf.cassandra.max_definition_cache_size
+        self._max_batches = conf.cassandra.max_batches
